--- MPlayer-1.0rc1/libmpcodecs/native/minilzo.c
+++ MPlayer-1.0rc1/libmpcodecs/native/minilzo.c
@@ -1596,280 +2479,271 @@
     ip += 4;
     for (;;)
     {
-#if 0 && defined(__GNUC__) && defined(__i386__)
-	register const lzo_byte *m_pos __asm__("%edi");
-#else
-	register const lzo_byte *m_pos;
-#endif
-	lzo_moff_t m_off;
-	lzo_uint m_len;
-	lzo_uint dindex;
-
-	DINDEX1(dindex,ip);
-	GINDEX(m_pos,m_off,dict,dindex,in);
-	if (LZO_CHECK_MPOS_NON_DET(m_pos,m_off,in,ip,M4_MAX_OFFSET))
-	    goto literal;
+        register const lzo_bytep m_pos;
+        lzo_uint m_off;
+        lzo_uint m_len;
+        lzo_uint dindex;
+
+        DINDEX1(dindex,ip);
+        GINDEX(m_pos,m_off,dict,dindex,in);
+        if (LZO_CHECK_MPOS_NON_DET(m_pos,m_off,in,ip,M4_MAX_OFFSET))
+            goto literal;
 #if 1
-	if (m_off <= M2_MAX_OFFSET || m_pos[3] == ip[3])
-	    goto try_match;
-	DINDEX2(dindex,ip);
-#endif
-	GINDEX(m_pos,m_off,dict,dindex,in);
-	if (LZO_CHECK_MPOS_NON_DET(m_pos,m_off,in,ip,M4_MAX_OFFSET))
-	    goto literal;
-	if (m_off <= M2_MAX_OFFSET || m_pos[3] == ip[3])
-	    goto try_match;
-	goto literal;
+        if (m_off <= M2_MAX_OFFSET || m_pos[3] == ip[3])
+            goto try_match;
+        DINDEX2(dindex,ip);
+#endif
+        GINDEX(m_pos,m_off,dict,dindex,in);
+        if (LZO_CHECK_MPOS_NON_DET(m_pos,m_off,in,ip,M4_MAX_OFFSET))
+            goto literal;
+        if (m_off <= M2_MAX_OFFSET || m_pos[3] == ip[3])
+            goto try_match;
+        goto literal;
 
 try_match:
 #if 1 && defined(LZO_UNALIGNED_OK_2)
-	if (* (const lzo_ushortp) m_pos != * (const lzo_ushortp) ip)
+        if (* (const lzo_ushortp) m_pos != * (const lzo_ushortp) ip)
 #else
-	if (m_pos[0] != ip[0] || m_pos[1] != ip[1])
+        if (m_pos[0] != ip[0] || m_pos[1] != ip[1])
 #endif
-	{
-	}
-	else
-	{
-	    if (m_pos[2] == ip[2])
-	    {
+        {
+        }
+        else
+        {
+            if __lzo_likely(m_pos[2] == ip[2])
+            {
 #if 0
-		if (m_off <= M2_MAX_OFFSET)
-		    goto match;
-		if (lit <= 3)
-		    goto match;
-		if (lit == 3)
-		{
-		    assert(op - 2 > out); op[-2] |= LZO_BYTE(3);
-		    *op++ = *ii++; *op++ = *ii++; *op++ = *ii++;
-		    goto code_match;
-		}
-		if (m_pos[3] == ip[3])
-#endif
-		    goto match;
-	    }
-	    else
-	    {
+                if (m_off <= M2_MAX_OFFSET)
+                    goto match;
+                if (lit <= 3)
+                    goto match;
+                if (lit == 3)
+                {
+                    assert(op - 2 > out); op[-2] |= LZO_BYTE(3);
+                    *op++ = *ii++; *op++ = *ii++; *op++ = *ii++;
+                    goto code_match;
+                }
+                if (m_pos[3] == ip[3])
+#endif
+                    goto match;
+            }
+            else
+            {
 #if 0
 #if 0
-		if (m_off <= M1_MAX_OFFSET && lit > 0 && lit <= 3)
+                if (m_off <= M1_MAX_OFFSET && lit > 0 && lit <= 3)
 #else
-		if (m_off <= M1_MAX_OFFSET && lit == 3)
+                if (m_off <= M1_MAX_OFFSET && lit == 3)
 #endif
-		{
-		    register lzo_uint t;
+                {
+                    register lzo_uint t;
 
-		    t = lit;
-		    assert(op - 2 > out); op[-2] |= LZO_BYTE(t);
-		    do *op++ = *ii++; while (--t > 0);
-		    assert(ii == ip);
-		    m_off -= 1;
-		    *op++ = LZO_BYTE(M1_MARKER | ((m_off & 3) << 2));
-		    *op++ = LZO_BYTE(m_off >> 2);
-		    ip += 2;
-		    goto match_done;
-		}
+                    t = lit;
+                    assert(op - 2 > out); op[-2] |= LZO_BYTE(t);
+                    do *op++ = *ii++; while (--t > 0);
+                    assert(ii == ip);
+                    m_off -= 1;
+                    *op++ = LZO_BYTE(M1_MARKER | ((m_off & 3) << 2));
+                    *op++ = LZO_BYTE(m_off >> 2);
+                    ip += 2;
+                    goto match_done;
+                }
 #endif
-	    }
-	}
+            }
+        }
 
 literal:
-	UPDATE_I(dict,0,dindex,ip,in);
-	++ip;
-	if (ip >= ip_end)
-	    break;
-	continue;
+        UPDATE_I(dict,0,dindex,ip,in);
+        ++ip;
+        if __lzo_unlikely(ip >= ip_end)
+            break;
+        continue;
 
 match:
-	UPDATE_I(dict,0,dindex,ip,in);
-	if (ip - ii > 0)
-	{
-	    register lzo_uint t = ip - ii;
-
-	    if (t <= 3)
-	    {
-		assert(op - 2 > out);
-		op[-2] |= LZO_BYTE(t);
-	    }
-	    else if (t <= 18)
-		*op++ = LZO_BYTE(t - 3);
-	    else
-	    {
-		register lzo_uint tt = t - 18;
-
-		*op++ = 0;
-		while (tt > 255)
-		{
-		    tt -= 255;
-		    *op++ = 0;
-		}
-		assert(tt > 0);
-		*op++ = LZO_BYTE(tt);
-	    }
-	    do *op++ = *ii++; while (--t > 0);
-	}
-
-	assert(ii == ip);
-	ip += 3;
-	if (m_pos[3] != *ip++ || m_pos[4] != *ip++ || m_pos[5] != *ip++ ||
-	    m_pos[6] != *ip++ || m_pos[7] != *ip++ || m_pos[8] != *ip++
+        UPDATE_I(dict,0,dindex,ip,in);
+        if (pd(ip,ii) > 0)
+        {
+            register lzo_uint t = pd(ip,ii);
+
+            if (t <= 3)
+            {
+                assert(op - 2 > out);
+                op[-2] |= LZO_BYTE(t);
+            }
+            else if (t <= 18)
+                *op++ = LZO_BYTE(t - 3);
+            else
+            {
+                register lzo_uint tt = t - 18;
+
+                *op++ = 0;
+                while (tt > 255)
+                {
+                    tt -= 255;
+                    *op++ = 0;
+                }
+                assert(tt > 0);
+                *op++ = LZO_BYTE(tt);
+            }
+            do *op++ = *ii++; while (--t > 0);
+        }
+
+        assert(ii == ip);
+        ip += 3;
+        if (m_pos[3] != *ip++ || m_pos[4] != *ip++ || m_pos[5] != *ip++ ||
+            m_pos[6] != *ip++ || m_pos[7] != *ip++ || m_pos[8] != *ip++
 #ifdef LZO1Y
-	    || m_pos[ 9] != *ip++ || m_pos[10] != *ip++ || m_pos[11] != *ip++
-	    || m_pos[12] != *ip++ || m_pos[13] != *ip++ || m_pos[14] != *ip++
+            || m_pos[ 9] != *ip++ || m_pos[10] != *ip++ || m_pos[11] != *ip++
+            || m_pos[12] != *ip++ || m_pos[13] != *ip++ || m_pos[14] != *ip++
 #endif
-	   )
-	{
-	    --ip;
-	    m_len = ip - ii;
-	    assert(m_len >= 3); assert(m_len <= M2_MAX_LEN);
-
-	    if (m_off <= M2_MAX_OFFSET)
-	    {
-		m_off -= 1;
+           )
+        {
+            --ip;
+            m_len = pd(ip, ii);
+            assert(m_len >= 3); assert(m_len <= M2_MAX_LEN);
+
+            if (m_off <= M2_MAX_OFFSET)
+            {
+                m_off -= 1;
 #if defined(LZO1X)
-		*op++ = LZO_BYTE(((m_len - 1) << 5) | ((m_off & 7) << 2));
-		*op++ = LZO_BYTE(m_off >> 3);
+                *op++ = LZO_BYTE(((m_len - 1) << 5) | ((m_off & 7) << 2));
+                *op++ = LZO_BYTE(m_off >> 3);
 #elif defined(LZO1Y)
-		*op++ = LZO_BYTE(((m_len + 1) << 4) | ((m_off & 3) << 2));
-		*op++ = LZO_BYTE(m_off >> 2);
+                *op++ = LZO_BYTE(((m_len + 1) << 4) | ((m_off & 3) << 2));
+                *op++ = LZO_BYTE(m_off >> 2);
 #endif
-	    }
-	    else if (m_off <= M3_MAX_OFFSET)
-	    {
-		m_off -= 1;
-		*op++ = LZO_BYTE(M3_MARKER | (m_len - 2));
-		goto m3_m4_offset;
-	    }
-	    else
+            }
+            else if (m_off <= M3_MAX_OFFSET)
+            {
+                m_off -= 1;
+                *op++ = LZO_BYTE(M3_MARKER | (m_len - 2));
+                goto m3_m4_offset;
+            }
+            else
 #if defined(LZO1X)
-	    {
-		m_off -= 0x4000;
-		assert(m_off > 0); assert(m_off <= 0x7fff);
-		*op++ = LZO_BYTE(M4_MARKER |
-				 ((m_off & 0x4000) >> 11) | (m_len - 2));
-		goto m3_m4_offset;
-	    }
+            {
+                m_off -= 0x4000;
+                assert(m_off > 0); assert(m_off <= 0x7fff);
+                *op++ = LZO_BYTE(M4_MARKER |
+                                 ((m_off & 0x4000) >> 11) | (m_len - 2));
+                goto m3_m4_offset;
+            }
 #elif defined(LZO1Y)
-		goto m4_match;
+                goto m4_match;
 #endif
-	}
-	else
-	{
-	    {
-		const lzo_byte *end = in_end;
-		const lzo_byte *m = m_pos + M2_MAX_LEN + 1;
-		while (ip < end && *m == *ip)
-		    m++, ip++;
-		m_len = (ip - ii);
-	    }
-	    assert(m_len > M2_MAX_LEN);
-
-	    if (m_off <= M3_MAX_OFFSET)
-	    {
-		m_off -= 1;
-		if (m_len <= 33)
-		    *op++ = LZO_BYTE(M3_MARKER | (m_len - 2));
-		else
-		{
-		    m_len -= 33;
-		    *op++ = M3_MARKER | 0;
-		    goto m3_m4_len;
-		}
-	    }
-	    else
-	    {
+        }
+        else
+        {
+            {
+                const lzo_bytep end = in_end;
+                const lzo_bytep m = m_pos + M2_MAX_LEN + 1;
+                while (ip < end && *m == *ip)
+                    m++, ip++;
+                m_len = pd(ip, ii);
+            }
+            assert(m_len > M2_MAX_LEN);
+
+            if (m_off <= M3_MAX_OFFSET)
+            {
+                m_off -= 1;
+                if (m_len <= 33)
+                    *op++ = LZO_BYTE(M3_MARKER | (m_len - 2));
+                else
+                {
+                    m_len -= 33;
+                    *op++ = M3_MARKER | 0;
+                    goto m3_m4_len;
+                }
+            }
+            else
+            {
 #if defined(LZO1Y)
 m4_match:
 #endif
-		m_off -= 0x4000;
-		assert(m_off > 0); assert(m_off <= 0x7fff);
-		if (m_len <= M4_MAX_LEN)
-		    *op++ = LZO_BYTE(M4_MARKER |
-				     ((m_off & 0x4000) >> 11) | (m_len - 2));
-		else
-		{
-		    m_len -= M4_MAX_LEN;
-		    *op++ = LZO_BYTE(M4_MARKER | ((m_off & 0x4000) >> 11));
+                m_off -= 0x4000;
+                assert(m_off > 0); assert(m_off <= 0x7fff);
+                if (m_len <= M4_MAX_LEN)
+                    *op++ = LZO_BYTE(M4_MARKER |
+                                     ((m_off & 0x4000) >> 11) | (m_len - 2));
+                else
+                {
+                    m_len -= M4_MAX_LEN;
+                    *op++ = LZO_BYTE(M4_MARKER | ((m_off & 0x4000) >> 11));
 m3_m4_len:
-		    while (m_len > 255)
-		    {
-			m_len -= 255;
-			*op++ = 0;
-		    }
-		    assert(m_len > 0);
-		    *op++ = LZO_BYTE(m_len);
-		}
-	    }
+                    while (m_len > 255)
+                    {
+                        m_len -= 255;
+                        *op++ = 0;
+                    }
+                    assert(m_len > 0);
+                    *op++ = LZO_BYTE(m_len);
+                }
+            }
 
 m3_m4_offset:
-	    *op++ = LZO_BYTE((m_off & 63) << 2);
-	    *op++ = LZO_BYTE(m_off >> 6);
-	}
+            *op++ = LZO_BYTE((m_off & 63) << 2);
+            *op++ = LZO_BYTE(m_off >> 6);
+        }
 
 #if 0
 match_done:
 #endif
-	ii = ip;
-	if (ip >= ip_end)
-	    break;
+        ii = ip;
+        if __lzo_unlikely(ip >= ip_end)
+            break;
     }
 
-    *out_len = op - out;
-    return (lzo_uint) (in_end - ii);
+    *out_len = pd(op, out);
+    return pd(in_end,ii);
 }
 
 LZO_PUBLIC(int)
-DO_COMPRESS      ( const lzo_byte *in , lzo_uint  in_len,
-			 lzo_byte *out, lzo_uint *out_len,
-			 lzo_voidp wrkmem )
+DO_COMPRESS      ( const lzo_bytep in , lzo_uint  in_len,
+                         lzo_bytep out, lzo_uintp out_len,
+                         lzo_voidp wrkmem )
 {
-    lzo_byte *op = out;
+    lzo_bytep op = out;
     lzo_uint t;
 
-#if defined(__LZO_QUERY_COMPRESS)
-    if (__LZO_IS_COMPRESS_QUERY(in,in_len,out,out_len,wrkmem))
-	return __LZO_QUERY_COMPRESS(in,in_len,out,out_len,wrkmem,D_SIZE,lzo_sizeof(lzo_dict_t));
-#endif
-
-    if (in_len <= M2_MAX_LEN + 5)
-	t = in_len;
+    if __lzo_unlikely(in_len <= M2_MAX_LEN + 5)
+        t = in_len;
     else
     {
-	t = do_compress(in,in_len,op,out_len,wrkmem);
-	op += *out_len;
+        t = do_compress(in,in_len,op,out_len,wrkmem);
+        op += *out_len;
     }
 
     if (t > 0)
     {
-	const lzo_byte *ii = in + in_len - t;
+        const lzo_bytep ii = in + in_len - t;
 
-	if (op == out && t <= 238)
-	    *op++ = LZO_BYTE(17 + t);
-	else if (t <= 3)
-	    op[-2] |= LZO_BYTE(t);
-	else if (t <= 18)
-	    *op++ = LZO_BYTE(t - 3);
-	else
-	{
-	    lzo_uint tt = t - 18;
-
-	    *op++ = 0;
-	    while (tt > 255)
-	    {
-		tt -= 255;
-		*op++ = 0;
-	    }
-	    assert(tt > 0);
-	    *op++ = LZO_BYTE(tt);
-	}
-	do *op++ = *ii++; while (--t > 0);
+        if (op == out && t <= 238)
+            *op++ = LZO_BYTE(17 + t);
+        else if (t <= 3)
+            op[-2] |= LZO_BYTE(t);
+        else if (t <= 18)
+            *op++ = LZO_BYTE(t - 3);
+        else
+        {
+            lzo_uint tt = t - 18;
+
+            *op++ = 0;
+            while (tt > 255)
+            {
+                tt -= 255;
+                *op++ = 0;
+            }
+            assert(tt > 0);
+            *op++ = LZO_BYTE(tt);
+        }
+        do *op++ = *ii++; while (--t > 0);
     }
 
     *op++ = M4_MARKER | 1;
     *op++ = 0;
     *op++ = 0;
 
-    *out_len = op - out;
+    *out_len = pd(op, out);
     return LZO_E_OK;
 }
 
@@ -1877,28 +2751,26 @@
 #undef DO_COMPRESS
 #undef LZO_HASH
 
-#undef LZO_TEST_DECOMPRESS_OVERRUN
-#undef LZO_TEST_DECOMPRESS_OVERRUN_INPUT
-#undef LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT
-#undef LZO_TEST_DECOMPRESS_OVERRUN_LOOKBEHIND
+#undef LZO_TEST_OVERRUN
 #undef DO_DECOMPRESS
 #define DO_DECOMPRESS       lzo1x_decompress
 
-#if defined(LZO_TEST_DECOMPRESS_OVERRUN)
-#  if !defined(LZO_TEST_DECOMPRESS_OVERRUN_INPUT)
-#    define LZO_TEST_DECOMPRESS_OVERRUN_INPUT       2
+#if defined(LZO_TEST_OVERRUN)
+#  if !defined(LZO_TEST_OVERRUN_INPUT)
+#    define LZO_TEST_OVERRUN_INPUT       2
 #  endif
-#  if !defined(LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT)
-#    define LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT      2
+#  if !defined(LZO_TEST_OVERRUN_OUTPUT)
+#    define LZO_TEST_OVERRUN_OUTPUT      2
 #  endif
-#  if !defined(LZO_TEST_DECOMPRESS_OVERRUN_LOOKBEHIND)
-#    define LZO_TEST_DECOMPRESS_OVERRUN_LOOKBEHIND
+#  if !defined(LZO_TEST_OVERRUN_LOOKBEHIND)
+#    define LZO_TEST_OVERRUN_LOOKBEHIND
 #  endif
 #endif
 
 #undef TEST_IP
 #undef TEST_OP
-#undef TEST_LOOKBEHIND
+#undef TEST_LB
+#undef TEST_LBO
 #undef NEED_IP
 #undef NEED_OP
 #undef HAVE_TEST_IP
@@ -1908,31 +2780,33 @@
 #undef HAVE_ANY_IP
 #undef HAVE_ANY_OP
 
-#if defined(LZO_TEST_DECOMPRESS_OVERRUN_INPUT)
-#  if (LZO_TEST_DECOMPRESS_OVERRUN_INPUT >= 1)
+#if defined(LZO_TEST_OVERRUN_INPUT)
+#  if (LZO_TEST_OVERRUN_INPUT >= 1)
 #    define TEST_IP             (ip < ip_end)
 #  endif
-#  if (LZO_TEST_DECOMPRESS_OVERRUN_INPUT >= 2)
+#  if (LZO_TEST_OVERRUN_INPUT >= 2)
 #    define NEED_IP(x) \
-	    if ((lzo_uint)(ip_end - ip) < (lzo_uint)(x))  goto input_overrun
+            if ((lzo_uint)(ip_end - ip) < (lzo_uint)(x))  goto input_overrun
 #  endif
 #endif
 
-#if defined(LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT)
-#  if (LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT >= 1)
+#if defined(LZO_TEST_OVERRUN_OUTPUT)
+#  if (LZO_TEST_OVERRUN_OUTPUT >= 1)
 #    define TEST_OP             (op <= op_end)
 #  endif
-#  if (LZO_TEST_DECOMPRESS_OVERRUN_OUTPUT >= 2)
+#  if (LZO_TEST_OVERRUN_OUTPUT >= 2)
 #    undef TEST_OP
 #    define NEED_OP(x) \
-	    if ((lzo_uint)(op_end - op) < (lzo_uint)(x))  goto output_overrun
+            if ((lzo_uint)(op_end - op) < (lzo_uint)(x))  goto output_overrun
 #  endif
 #endif
 
-#if defined(LZO_TEST_DECOMPRESS_OVERRUN_LOOKBEHIND)
-#  define TEST_LOOKBEHIND(m_pos,out)    if (m_pos < out) goto lookbehind_overrun
+#if defined(LZO_TEST_OVERRUN_LOOKBEHIND)
+#  define TEST_LB(m_pos)        if (m_pos < out || m_pos >= op) goto lookbehind_overrun
+#  define TEST_LBO(m_pos,o)     if (m_pos < out || m_pos >= op - (o)) goto lookbehind_overrun
 #else
-#  define TEST_LOOKBEHIND(m_pos,op)     ((void) 0)
+#  define TEST_LB(m_pos)        ((void) 0)
+#  define TEST_LBO(m_pos,o)     ((void) 0)
 #endif
 
 #if !defined(LZO_EOF_CODE) && !defined(TEST_IP)
@@ -1968,26 +2842,36 @@
 #  define HAVE_ANY_OP
 #endif
 
+#undef __COPY4
+#define __COPY4(dst,src)    * (lzo_uint32p)(dst) = * (const lzo_uint32p)(src)
+
+#undef COPY4
+#if defined(LZO_UNALIGNED_OK_4)
+#  define COPY4(dst,src)    __COPY4(dst,src)
+#elif defined(LZO_ALIGNED_OK_4)
+#  define COPY4(dst,src)    __COPY4((lzo_uintptr_t)(dst),(lzo_uintptr_t)(src))
+#endif
+
 #if defined(DO_DECOMPRESS)
 LZO_PUBLIC(int)
-DO_DECOMPRESS  ( const lzo_byte *in , lzo_uint  in_len,
-		       lzo_byte *out, lzo_uint *out_len,
-		       lzo_voidp wrkmem )
+DO_DECOMPRESS  ( const lzo_bytep in , lzo_uint  in_len,
+                       lzo_bytep out, lzo_uintp out_len,
+                       lzo_voidp wrkmem )
 #endif
 {
-    register lzo_byte *op;
-    register const lzo_byte *ip;
+    register lzo_bytep op;
+    register const lzo_bytep ip;
     register lzo_uint t;
 #if defined(COPY_DICT)
     lzo_uint m_off;
-    const lzo_byte *dict_end;
+    const lzo_bytep dict_end;
 #else
-    register const lzo_byte *m_pos;
+    register const lzo_bytep m_pos;
 #endif
 
-    const lzo_byte * const ip_end = in + in_len;
+    const lzo_bytep const ip_end = in + in_len;
 #if defined(HAVE_ANY_OP)
-    lzo_byte * const op_end = out + *out_len;
+    lzo_bytep const op_end = out + *out_len;
 #endif
 #if defined(LZO1Z)
     lzo_uint last_m_off = 0;
@@ -1995,25 +2879,20 @@
 
     LZO_UNUSED(wrkmem);
 
-#if defined(__LZO_QUERY_DECOMPRESS)
-    if (__LZO_IS_DECOMPRESS_QUERY(in,in_len,out,out_len,wrkmem))
-	return __LZO_QUERY_DECOMPRESS(in,in_len,out,out_len,wrkmem,0,0);
-#endif
-
 #if defined(COPY_DICT)
     if (dict)
     {
-	if (dict_len > M4_MAX_OFFSET)
-	{
-	    dict += dict_len - M4_MAX_OFFSET;
-	    dict_len = M4_MAX_OFFSET;
-	}
-	dict_end = dict + dict_len;
+        if (dict_len > M4_MAX_OFFSET)
+        {
+            dict += dict_len - M4_MAX_OFFSET;
+            dict_len = M4_MAX_OFFSET;
+        }
+        dict_end = dict + dict_len;
     }
     else
     {
-	dict_len = 0;
-	dict_end = NULL;
+        dict_len = 0;
+        dict_end = NULL;
     }
 #endif
 
